#include <bits/stdc++.h>
#define endl '\n'

//#pragma optimize ("O3")
//#pragma target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);
const int mod = (int)1e9 + 7;

struct state
{
    vector<int> d;
    void init(int n) { d.assign(n, 0); }
    void fix() { sort(d.begin(), d.end()); }
    uint64_t get_hash()
    {
        uint64_t v = 0;
        for(int x: d) v = v * 15 + x;
        return v;
    }
};

char m[12];

int n;
string s;

void read()
{
    cin >> n;
    cin >> s;
}

unordered_map<uint64_t, int> memo;

int rec(state it, int da)
{
    if(da == n * 12) return 1;

    uint64_t h = it.get_hash();
    if(memo.count(h)) return memo[h];

    int answer = 0;
    for(int i = 0; i < n; i++)
        if(it.d[i] < 12 && s[da] == '?' || m[it.d[i]] == s[da])
        {
            state nxt = it;
            nxt.d[i]++;
            nxt.fix();
            answer = (answer + rec(nxt, da + 1)) % mod;
        }

    return memo[h] = answer;
}

void solve()
{
    state tmp;
    tmp.init(n);

    m[0] = 'J';
    m[1] = 'F';
    m[2] = 'M';
    m[3] = 'A';
    m[4] = 'M';
    m[5] = 'J';
    m[6] = 'J';
    m[7] = 'A';
    m[8] = 'S';
    m[9] = 'O';
    m[10] = 'N';
    m[11] = 'D';

    cout << rec(tmp, 0) << endl;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
