#include <bits/stdc++.h>
#include "bookshelf.h"
//#include "Lgrader.cpp"
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

int rp[MAXN], p[MAXN];
int64_t inv;

int cmp(int l, int r)
{
    int64_t nw = bookswap(l, r);
    swap(p[l], p[r]);
    if(nw < inv) { inv = nw; return 2; }
    else { swap(p[l], p[r]); bookswap(l, r); return 1; }
}

void rec(int l, int r)
{
    if(l == r) return;

    int mid = (l + r) >> 1;
    rec(l, mid);
    rec(mid + 1, r);

    int l1 = l, l2 = mid + 1;
    while(l1 <= mid && l2 <= r)
    {
        if(cmp(l1, l2) == 1) l1++;
        else l2++;
    }
}


void bookshelf(int n, long long c_inv)
{
    inv = c_inv;
    for(int i = 1; i <= n; i++) p[i] = i;
    rec(1, n);

    for(int i = 1; i <= n; i++) rp[p[i]] = i;
    answer(rp);
}
