#include <bits/stdc++.h>
#include "bookshelf.h"
//#include "Lgrader.cpp"
#define endl '\n'

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (1 << 20);

int rp[MAXN], p[MAXN];
int64_t inv;

int cmp(int l, int r)
{
    int64_t nw = bookswap(l, r);
    swap(p[l], p[r]);
    if(nw < inv) { swap(p[l], p[r]); bookswap(l, r); return 2; }
    else { swap(p[l], p[r]); bookswap(l, r); return 1; }
}

int po[MAXN];

void rec(int l, int r)
{
    if(l == r) return;

    int mid = (l + r) >> 1;
    rec(l, mid);
    rec(mid + 1, r);

    int l1 = l, l2 = mid + 1;
    vector<int> ord;
    while(l1 <= mid && l2 <= r)
    {
        if(cmp(l1, l2) == 1) ord.push_back(p[l1++]);
        else ord.push_back(p[l2++]);
    }

    while(l1 <= mid) ord.push_back(p[l1++]);
    while(l2 <= r) ord.push_back(p[l2++]);

    for(int i = l; i <= r; i++) po[p[i]] = i;

    for(int i = l; i <= r; i++)
        if(p[i] != ord[i - l])
        {
            int r = po[ord[i - l]];

            inv = bookswap(i, r);
            po[ord[i - l]] = i;
            po[p[i]] = r;
            swap(p[i], p[r]);
        }
}

void bookshelf(int n, long long c_inv)
{
    inv = c_inv;
    for(int i = 1; i <= n; i++) p[i] = i;
    rec(1, n);

    for(int i = 1; i <= n; i++) rp[p[i]] = i;
    answer(rp);
}
