#include<iostream>
#include<vector>
#include<algorithm>
#include<unordered_map>
//#include<time.h>
using namespace std;

const long long MOD=1000000007;
const long long MOD2=(1e16)+19;
const long long BASE=13;
const int MAX_N=13;
int n;
string s;
long long ans;
vector<int> ts[16];

unordered_map<long long, int> mp;

struct State
{
    int t[MAX_N];
    long long c;
};
vector<State> v[2];
bool cv=0;

long long hashState(const State& a)
{
    long long h=0;
    for (int i=0;i<n;++i)
    {
        h*=BASE;
        h+=a.t[i];
        h%=MOD2;
    }
    return h;
}

bool operator<(const State& a, const State& b)
{
    for (int i=0;i<n;++i)
    {
        if (a.t[i]==b.t[i]) continue;
        return a.t[i]<b.t[i];
    }
    return 0;
}

void input()
{
    //n=13;
    cin>>n;
    cin>>s;
}
void output()
{
    cout<<ans<<endl;
}
void init()
{
    ts[1].push_back(1);
    ts[1].push_back(6);
    ts[1].push_back(7);

    ts[2].push_back(2);

    ts[3].push_back(3);
    ts[3].push_back(5);

    ts[4].push_back(4);
    ts[4].push_back(8);

    ts[9].push_back(9);

    ts[10].push_back(10);

    ts[11].push_back(11);

    ts[12].push_back(12);

    ts[13].push_back(1);
    ts[13].push_back(2);
    ts[13].push_back(3);
    ts[13].push_back(4);
    ts[13].push_back(5);
    ts[13].push_back(6);
    ts[13].push_back(7);
    ts[13].push_back(8);
    ts[13].push_back(9);
    ts[13].push_back(10);
    ts[13].push_back(11);
    ts[13].push_back(12);
}
long long total=0;
void solve()
{
    State next;
    for (int i=0;i<n;++i)
    {
        next.t[i]=0;
    }
    next.c=1;
    v[cv].push_back(next);
    int cm;
    int first,coun;
    long long ch;
    for (int ii=0;ii<12*n;++ii)
    {
        v[!cv].resize(0);
        mp.clear();
        if (s[ii]=='J') cm=1;
        if (s[ii]=='F') cm=2;
        if (s[ii]=='M') cm=3;
        if (s[ii]=='A') cm=4;
        if (s[ii]=='S') cm=9;
        if (s[ii]=='O') cm=10;
        if (s[ii]=='N') cm=11;
        if (s[ii]=='D') cm=12;
        if (s[ii]=='?') cm=13;
        //cm=13;
        //cerr<<' '<<v[cv].size()<<endl;
        total+=v[cv].size();
        const vector<int>& pos=ts[cm];
        for (int i=0;i<v[cv].size();++i)
        {
            v[cv][i].c%=MOD;
            const State& curr=v[cv][i];
            /*for (int j=0;j<n;++j)
            {
                cerr<<' '<<curr.t[j];
            }
            cerr<<'\n';
            cerr<<" - "<<curr.c<<endl;*/
            for (int k=0;k<pos.size();++k)
            {
                coun=0;
                for (int j=0;j<n;++j)
                {
                    if (curr.t[j]==pos[k]-1)
                    {
                        if (coun==0) first=j;
                        ++coun;
                    }
                }
                //cerr<<"  "<<pos[k]<<' '<<coun<<endl;
                if (coun==0) continue;
                next=curr;
                next.c*=coun;
                //next.c%=MOD;
                ++next.t[first];
                ch=hashState(next);
                if (mp.find(ch)==mp.end())
                {
                    mp[ch]=v[!cv].size();
                    v[!cv].push_back(next);
                }
                else
                {
                    v[!cv][mp[ch]].c+=next.c;
                    //v[!cv][mp[ch]].c%=MOD;
                }
            }
        }
        cv=!cv;
        /*v[!cv].resize(0);
        sort(v[cv].begin(),v[cv].end());
        for (int i=0;i<v[cv].size();++i)
        {
            if (i==0 || v[cv][i-1]<v[cv][i])
            {
                v[!cv].push_back(v[cv][i]);
            }
            else
            {
                v[!cv][v[!cv].size()-1].c+=v[cv][i].c;
                v[!cv][v[!cv].size()-1].c%=MOD;
            }
        }
        cv=!cv;*/

    }
    //cerr<<total<<endl;
    ans=0;
    for (int i=0;i<v[cv].size();++i)
    {
        ans+=v[cv][i].c;
        ans%=MOD;
    }
}
//time_t startT,currT;
int main()
{
    //startT=clock();

    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    init();
    solve();
    output();

    //currT=clock();

    //cerr<<(currT-startT)*1.0/CLOCKS_PER_SEC<<endl;

    return 0;
}
