#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 16;
const int MOD = (1e9) + 7;
const unsigned long long BASE = 17;

const char ORDER[12] = {
  'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'
};

int n;
char s[N*12];
unordered_map < unsigned long long, int > state;
vector < char > cnt;

unsigned long long get_hash(vector < char > cnt) {
  unsigned long long ans=0;
  int i;

  for(i=0;i<13;i++) {
    ans*=BASE;
    ans+=cnt[i];
  }

  return ans;
}

int recurse(int pos, vector < char > cnt) {
  if(pos>12*n) return 1;//return cnt[12]==n ? 1 : 0;

  unsigned long long h=get_hash(cnt);

  if(state.find(h)!=state.end()) return state[h];

  int i;
  unsigned long long ans=0;

  for(i=0;i<12;i++) if(cnt[i]>0 && (s[pos]=='?' || s[pos]==ORDER[i])) {
    ++cnt[i+1];
    --cnt[i];

    ans+=recurse(pos+1,cnt)*1llu*(cnt[i]+1);
  
    --cnt[i+1];
    ++cnt[i];
  }

  return state[h]=ans%MOD;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  scanf("%d", &n);
  scanf("%s", s+1);

  cnt.assign(13,0);
  cnt[0]=n;
  
  printf("%d\n", recurse(1,cnt));
  
  return 0;
}
