#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const unsigned long long BASE = 17;
const char ORDER[12] = {
  'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'
};
const int MOD = (1e9) + 7;

unsigned long long pw[20];
char s[16*13];
int n;
int cnt[16];
unordered_map < unsigned long long, int > state;

void compute_state() {
  unsigned long long h=0,curr_h;
  int pos=1,i;
  unsigned long long ans=0;

  for(i=12;i>=0;i--) {
    pos+=cnt[i]*i;
    h*=BASE;
    h+=cnt[i];
  }

  if(pos>12*n) {
    state[h]=1;
    return;
  }

	for(i=0;i<12;i++) if(cnt[i]>0 && (s[pos]=='?' || s[pos]==ORDER[i])) {
    curr_h=h;
   
    curr_h+=pw[i+1];
    curr_h-=pw[i];
    //++cnt[i+1];
    //--cnt[i];

    ans+=state[curr_h]*1llu*cnt[i];
  
    //--cnt[i+1];
    //++cnt[i];
  }
  
  state[h]=ans%MOD;
}

void generate(int idx, int rem) {
  if(idx==12) {
    cnt[idx]=rem;

    compute_state();

    return;
  }

  for(int i=0;i<=rem;i++) {
    cnt[idx]=i;
    generate(idx+1,rem-i);
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i;
  unsigned long long h=0;

  pw[0]=1;
  for(i=1;i<20;i++) {
    pw[i]=pw[i-1]*BASE;
  }

  scanf("%d", &n);
  scanf("%s", s+1);

  generate(0,n);

  memset(cnt,0,sizeof(cnt));
  cnt[0]=n;
  for(i=12;i>=0;i--) {
    h*=BASE;
    h+=cnt[i];
  }

  printf("%d\n", state[h]);
  fprintf(stderr, "Time: %d ms\n", (int)(clock()*1000.0/CLOCKS_PER_SEC));

  return 0;
}
