#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const unsigned long long BASE = 17;
const char ORDER[12] = {
  'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'
};
const int MOD = (1e9) + 7;

unsigned long long pw[20];
char s[16*13];
int n,f[16][16];
int cnt[16];
int state[6000007];

int get_index() {
  int i,ans=1,pos,rem=n;

  for(pos=0;pos<12;pos++) {
    for(i=0;i<cnt[pos];i++) {
      ans+=f[12-pos][rem-i];
    }
    rem-=cnt[pos];
  }

  return ans;
}

void compute_state() {
  int idx=get_index();
  int pos=1,i;
  unsigned long long ans=0;

  for(i=0;i<=12;i++) pos+=i*cnt[i];

  if(pos>12*n) {
    state[idx]=1;
    return;
  }

	for(i=0;i<12;i++) if(cnt[i]>0 && (s[pos]=='?' || s[pos]==ORDER[i])) {
    ++cnt[i+1];
    --cnt[i];

    ans+=state[get_index()]*1llu*(cnt[i]+1);
  
    --cnt[i+1];
    ++cnt[i];
  }
  
  state[idx]=ans%MOD;
}

void generate(int idx, int rem) {
  if(idx==12) {
    cnt[idx]=rem;

    compute_state();

    return;
  }

  for(int i=0;i<=rem;i++) {
    cnt[idx]=i;
    generate(idx+1,rem-i);
  }
}

int get_f(int x, int y) {
  long long ans=1,n=x-1+y,k1=x-1,k2=y,i,i1=1,i2=1;

  for(i=1;i<=n;i++) {
    ans*=i;
    while(i1<=k1 && ans%i1==0) ans/=i1,++i1;
    while(i2<=k2 && ans%i2==0) ans/=i2,++i2;
  }

  return ans;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,j;
  unsigned long long h=0;

  pw[0]=1;
  for(i=1;i<20;i++) {
    pw[i]=pw[i-1]*BASE;
  }

  scanf("%d", &n);
  scanf("%s", s+1);

  for(i=1;i<=13;i++) {
    for(j=1;j<=13;j++) {
      f[i][j]=get_f(i,j);
    }
  }

  generate(0,n);

  memset(cnt,0,sizeof(cnt));
  cnt[0]=n;

  printf("%d\n", state[get_index()]);
  fprintf(stderr, "Time: %d ms\n", (int)(clock()*1000.0/CLOCKS_PER_SEC));

  return 0;
}
