#include<iostream>
#include "bookshelf.h"
using namespace std;

long long currInv;
long long invers[100005],pos[100005];
void merge(int from,int mid,int to){
	int last=from-1;
	for(int i=mid;i<to;i++){
		int curr=i-1;
		while(curr>last){
			long long val=bookswap(curr+1,curr+2);
			if(val>currInv){
				bookswap(curr+1,curr+2);
				last=curr+1;
				break;
			}
			currInv=val;
			invers[pos[curr]]++;
			swap(pos[curr],pos[curr+1]);
			curr--;
		}
	}
}

void merge_sort(int from,int to){
	if(from+1==to) return;
	int mid=(from+to)/2;
	merge_sort(from,mid);
	merge_sort(mid,to);
	merge(from,mid,to);
}

int ansP[100005];
void bookshelf(int n,long long inv){
	currInv=inv;
	for(int i=0;i<n;i++) pos[i]=i;
	merge_sort(0,n);
	int found=0;
	for(int i=0;i<n;i++){
		int tek=found;
		for(int j=0;j<n;j++){
			if(ansP[j+1]!=0){
				tek--;
				continue;
			}
			if(invers[j]==(n-1-j-tek)){
				ansP[j+1]=n-found;
				found++;
				break;
			}
		}
	}
	answer(ansP);
}
