#include<iostream>
#include<queue>
using namespace std;
const int MAXN=100005;
struct tree{
	tree *leftT,*rightT;
	long long sum,beg,k;
	tree(){
		leftT=nullptr;
		rightT=nullptr;
		sum=0;
		beg=0;
		k=0;
	}
};
void eraser(tree* &vert){
	if(vert==nullptr) return;
	eraser(vert->leftT);
	eraser(vert->rightT);
	delete vert;
	vert=nullptr;
}
tree* rows[MAXN];
long long beg,k;
int interI,interJ;
void addArithm(int a,int b,tree* &vert){
	if(interJ<a||b<interI||a>b) return;
	if(vert==nullptr){
		vert=new tree;
	}
	int len=b-a+1;
	if(interI<=a&&b<=interJ){
		beg+=(a-interI)*k;
		vert->sum+=len*beg+(len*(len-1)/2)*k;
		vert->beg+=beg;
		vert->k+=k;
		return;
	}
	vert->sum=len*vert->beg+(len*(len-1)/2)*vert->k;
	addArithm(a,(a+b)/2,vert->leftT);
	if(vert->leftT!=nullptr){
		vert->sum+=vert->leftT->sum;
	}
	addArithm((a+b)/2+1,b,vert->rightT);
	if(vert->rightT!=nullptr){
		vert->sum+=vert->rightT->sum;
	}
}
long long sum(int a,int b,tree* vert){
	if(vert==nullptr) return 0;
	if(interJ<a||b<interI||a>b) return 0;
	if(interI<=a&&b<=interJ){
		return vert->sum;
	}
	int beg=max(a,interI);
	int ender=min(b,interJ);
	int len=ender-beg+1;
	long long ans=len*(vert->beg+(beg-a)*vert->k)+(len*(len-1)/2)*vert->k;
	ans+=sum(a,(a+b)/2,vert->leftT);
	ans+=sum((a+b)/2+1,b,vert->rightT);
	return ans;
}
void copyT(tree* &vert,tree* temp){
	if(temp==nullptr){
		if(vert!=nullptr) eraser(vert);
		return;
	}
	if(vert==nullptr){
		vert=new tree;
	}
	vert->sum=temp->sum;
	vert->beg=temp->beg;
	vert->k=temp->k;
	copyT(vert->leftT,temp->leftT);
	copyT(vert->rightT,temp->rightT);
}
int last[MAXN];
int quer[MAXN][6];
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,q;
	cin>>n>>q;
	int t,r,a,b;
	for(int i=0;i<q;i++){
		cin>>t>>r;
		r--;
		quer[i][0]=t;
		quer[i][1]=r;
		if(t==1){
			cin>>a>>b>>beg>>k;
			quer[i][2]=a;
			quer[i][3]=b;
			quer[i][4]=beg;
			quer[i][5]=k;
		}
		if(t==2){
			last[r]=i;
			cin>>quer[i][2]>>quer[i][3];
		}
		if(t==3){
			last[r]=i;
			cin>>quer[i][2];
			quer[i][2]--;
		}
	}
	for(int i=0;i<q;i++){
		if(quer[i][0]==1){
			if(i>last[quer[i][1]]) continue;
			interI=quer[i][2];
			interJ=quer[i][3];
			beg=quer[i][4];
			k=quer[i][5];
			addArithm(1,n,rows[quer[i][1]]);
		}
		if(quer[i][0]==2){
			interI=quer[i][2];
			interJ=quer[i][3];
			cout<<sum(1,n,rows[quer[i][1]])<<"\n";
		}
		if(quer[i][0]==3){
			copyT(rows[quer[i][2]],rows[quer[i][1]]);
		}
		if(last[quer[i][1]]==i) eraser(rows[quer[i][1]]);
	}
	return 0;
}
