# include <cstdio>
# include <vector>
# include <map>
# include <algorithm>

using namespace std;

const int MAX_N = 13;
const int MOD = 1000000007;

int n;

char s[MAX_N * 12];

char mo[13] = {'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D', '#'};

map <vector <int>, int> m;

int go (int x, vector <int> st)
{
	if (x == n * 12)
		return true;
		
	if (m.find (st) != m.end ())
		return m[st];
		
	int ans = 0;
		
	for (int i = 0; i < n; i ++)
	{
		if (st[i] < 12 && (s[x] == '?' || mo[st[i]] == s[x]))
		{
			st[i] ++;
			ans += go (x + 1, st);
			if (ans >= MOD)
				ans -= MOD;
				
			st[i] --;
		}
	}
	
	m[st] = ans;
	return ans;
}

int main ()
{
	int i;
	
	scanf ("%d", &n);
	scanf ("%s", s);
	
	vector <int> st;
	
	for (i = 0; i < n; i ++)
		st.push_back (0);
	
	printf ("%d\n", go (0, st));

	return 0;
}

