# include "bookshelf.h"
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int ans[MAX_N];

int pos[MAX_N];

long long invn;

int cnt;

bool comp (int x, int y)
{
	if (cnt == 200000)
		return rand () & 1;
	long long old = invn;
	bool fl = false;
	if (pos[x] > pos[y])
		fl = true;
	
	invn = bookswap (pos[x], pos[y]);
	swap (pos[x], pos[y]);
	
	cnt ++;
	
	return (old > invn) ^ fl;
}

vector <int> ord (int l, int r)
{
	vector <int> f (r - l + 1);
	
	if (l == r)
	{
		f[0] = l;
		return f;
	}	

	int mid = (l + r) >> 1;
	
	vector <int> left = ord (l, mid);
	vector <int> right = ord (mid + 1, r);
	
	int ll = 0, rr = 0;
	
	int i = 0;
	
	while (ll < left.size () && rr < right.size ())
	{
		if (comp (left[ll], right[rr]))
			f[i ++] = right[rr ++];
		else
			f[i ++] = left[ll ++];	
	}
	while (ll < left.size ())
		f[i ++] = left[ll ++];	
	while (rr < right.size ())
		f[i ++] = right[rr ++];
	/**	
	printf ("-- %d %d\n", l, r);
	for (i = 0; i < (int) f.size (); i ++)
		printf ("%d ", f[i]);
	printf ("\n");
	**/
	return f;
		
}

void bookshelf (int n, long long inv)
{
	
	invn = inv;
	
	int i;
	
	for (i = 1; i <= n; i ++)
		pos[i] = i;
	
	vector <int> ms = ord (1, n);
	
	
	for (i = 0; i < n; i ++)
		ans[ms[i]] = i + 1;
		
	answer (ans);
}

