#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include "bookshelf.h"
using namespace std;
long long bookswap(int i, int j);
void answer(int p[]);
int tree[2][400005];
int a[100005];
void update(int id, int idx, int l, int r, int x, int st)
{
    if(l>r||l>x||r<x)
        return;
    if(l==r)
    {
        tree[id][idx]=st;
        return;
    }
    int mid=(l+r)/2;
    update(id,idx*2,l,mid,x,st);
    update(id,idx*2+1,mid+1,r,x,st);
    tree[id][idx]=tree[id][idx*2]+tree[id][idx*2+1];
}
int query(int id, int idx, int l, int r, int x)
{
    if(l==r)
    {
        return l;
    }
    int mid=(l+r)/2;
    if(x<=tree[id][idx*2])
    {
        return query(id,idx*2,l,mid,x);
    }
    return query(id,idx*2+1,mid+1,r,x-tree[id][idx*2]);
}
void bookshelf(int N, long long Inv)
{
    int i,j;
    int down=N-1;
    a[N]=N;
    for(i=1;i<=N;i++)
    {
        a[i]=i;
        update(0,1,1,N,i,1);
        update(1,1,1,N,i,1);
    }
    long long x;
    int y;
    for(i=1;i<N;i++)
    {
        x=bookswap(i,N);
        if(x<Inv)
        {
            y=query(0,1,1,N,(Inv-x+1)/2);
            a[i]=N+y;
            update(0,1,1,N,y,0);
        }
        else
        {
            y=query(1,1,1,N,(x-Inv+1)/2);
            a[i]=N-y;
            if(a[i]<=down)
            {
                down=a[i]-1;
            }
            update(1,1,1,N,y,0);
        }
        x=bookswap(i,N);
        //printf("%d\n", a[i]);
    }
    for(i=1;i<=N;i++)
    {
        a[i]-=down;
    }
    answer(a);
}
