#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MOD = 1e9 + 7;

const char MONTHS[] = { 'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D' };

int16_t n;
map< vector< int16_t >, int32_t > dp;
string s;

int32_t Solve(vector< int16_t > &state, int32_t ind) {
	if(ind == 12 * n) {
		return 1ll;
	}
	else if(dp.count(state) != 0) {
		return dp[state];
	}

	int32_t ans = 0;
	for(int16_t i = 0; i < n; i++) {
		if(state[i] != 12 && (MONTHS[state[i]] == s[ind] || s[ind] == '?')) {
			state[i]++;
			ans = (1ll * ans + 1ll * Solve(state, ind + 1)) % MOD;
			state[i]--;
		}
	}
	
	/**
	for(int32_t i = 0; i < n; i++) {
		cout << state[i] << " ";
	}
	cout << "-> " << ans << endl;
	*/

	dp[state] = ans;
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n >> s;

	vector< int16_t > state;
	state.resize(n, 0);

	cout << Solve(state, 0) << endl;
	return 0;
}
