#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MOD = 1e9 + 7;

const char MONTHS[] = { 'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D' };

int16_t n;
map< vector< int16_t >, int32_t > dp;
string s;

int32_t CalcDp(vector< int16_t > &state, int16_t ind) {
	if(ind == 12 * n) {
		return 1ll;
	}
	else if(dp.count(state) != 0) {
		return dp[state];
	}

	int32_t ans = 0;
	for(int32_t i = 0; i < 12; i++) {
		if(s[ind] == '?' || s[ind] == MONTHS[i]) {
			if(state[i] == 0) {
				continue;
			}

			state[i]--;
			if(i != 11) {
				state[i + 1]++;
			}
			ans = (1ll * ans + 1ll * (state[i] + 1) * CalcDp(state, ind + 1)) % MOD;
			
			if(i != 11) {
				state[i + 1]--;
			}
			state[i]++;
		}	
	}
	
	dp[state] = ans;
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cin >> n >> s;

	vector< int16_t > state;
	state.resize(12);
	state[0] = n;

	cout << CalcDp(state, 0) << endl;
	return 0;
}
