#include <iostream>
#include <vector>
#include <stack>
using namespace std;
struct upd {
    int l, r, s, d, toInd;
};
vector < vector < int > > tr;
vector < vector < pair < int, int> > > q2;
vector < vector < int > > ind2;
vector < int > onInd;
int sz;
vector < long long > ans;
vector < upd > parU;

int k;

struct v {
    long long toAddS, toAddD;
    long long sum;
    int sz;
};
vector < v > it;

void refr( int x ) {

    if ( it[x].toAddD == 0 && it[x].toAddS == 0 ) { return ; }

    it[x*2].toAddS += it[x].toAddS;
    it[x*2].toAddD += it[x].toAddD;
    it[x*2].sum += ( it[x].toAddS*2 + it[x].toAddD*(it[x].sz/2-1) )*it[x].sz/2/2;

    long long ns = it[x].toAddS + it[x].toAddD*it[x].sz/2;
    int sz = it[x].sz/2;
//    cout << it[x].toAddS << " " << it[x].toAddD
 //       << " => " << it[x*2+1].toAddS << " and " << it[x*2+1].toAddD << " , " << it[x*2+1].sum << "\n";

    it[x*2+1].toAddS += it[x].toAddS + it[x].toAddD*it[x].sz/2;
    it[x*2+1].toAddD += it[x].toAddD;
    it[x*2+1].sum += ( ns*2 + it[x].toAddD*(sz-1) )*sz/2;

   // cout << it[x].toAddS << " " << it[x].toAddD
   //     << " => " << it[x*2+1].toAddS << " and " << it[x*2+1].toAddD << " , " << it[x*2+1].sum << "\n";

    it[x].toAddD = 0;
    it[x].toAddS = 0;

}

void add ( int l, int r, long long s, long long d, int ll = 0, int rr = (1<<k), int ind = 1 ) {
    if ( l <= ll && rr <= r ) {
        long long dd = ll - l;
        s += dd*d;

        it[ind].toAddS += s;
        it[ind].toAddD += d;

     //   cout << "in upd " << ll << " " << rr << " : " << s << " " << d << "\n";

        it[ind].sum += ( 2*s + (it[ind].sz-1)*d )*it[ind].sz/2;

        return;
    }
    if ( rr <= l || r <= ll ) { return; }

    refr( ind );

    add( l, r, s, d, ll, (ll+rr)/2, ind*2 );
    add( l, r, s, d, (ll+rr)/2, rr, ind*2+1 );

    it[ind].sum = it[ ind*2 ].sum + it[ind*2+1].sum;

}
long long sum ( int l, int r, int ll = 0, int rr = (1<<k), int ind = 1 ) {
    if ( l <= ll && rr <= r ) {

    //    cout << "sum: " << ll << " " << rr << " : " << it[ind].sum << "\n";
        return it[ind].sum;
    }
    if ( rr <= l || r <= ll ) { return 0; }

    refr(ind);
    return sum(l, r, ll, (ll+rr)/2, ind*2 ) + sum( l, r, (ll+rr)/2, rr, ind*2+1 );
}

stack< int > stt;
stack< bool > estt;
vector < int > dfsOr;
vector < bool > es;

void dfs2( int z ) {

    stt.push( 0 );
    estt.push( 0 );

    dfsOr.clear();
    int x;
    bool b;

    for ( ; !stt.empty() ; ) {
        x = stt.top(); stt.pop();
        b = estt.top(); estt.pop();

      //  cout << "entering " << x << "\n";
        dfsOr.push_back( x );
        es.push_back( b );

        if ( b ) { continue; }
        stt.push( x );
        estt.push( 1 );

        for ( int i = 0 ; i < tr[x].size() ; i ++ ) {
            stt.push( tr[x][i] );
            estt.push( 0 );
        }
    }
}

/*
void dfs ( long long x ) {

    for ( long long i = 0 ; i < ind2[x].size() ; i ++ ) {
    //    cout << q2[x][i].first << " " << q2[x][i].second << "   =   " << sum( q2[x][i].first, q2[x][i].second ) << "\n";
        ans[ ind2[x][i] ] = sum( q2[x][i].first, q2[x][i].second );
    }

    for ( long long i = 0 ; i< tr[x].size() ; i ++ ) {
   //     cout << "adding " << tr[x][i].l << " " << tr[x][i].r << " " << tr[x][i].s << " " << tr[x][i].d << "\n";
        add( tr[x][i].l, tr[x][i].r, tr[x][i].s, tr[x][i].d );
        dfs ( tr[x][i].toInd );
        add( tr[x][i].l, tr[x][i].r, -tr[x][i].s, -tr[x][i].d );
    //    cout << "-adding " << tr[x][i].l << " " << tr[x][i].r << " " << tr[x][i].s << " " << tr[x][i].d << "\n";
    }

}
*/

int main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    sz = 1;
    long long q2sz = 0;

    long long n, q;


    int y, l, r, s, d;
    int y1, y2;

    cin >> n >> q;
    upd cc;
    cc.s = 0;
    cc.d = 0;
    cc.l = 0;
    cc.r = 0;

    vector < int > tmp;
    vector < pair < int, int > > tmp2;

    tr.resize( q+42 );
    ind2.resize( q+42 );
    q2.resize( q+42 );
    onInd.resize( q+42 );
    ans.resize( q+42 );
    parU.resize( q+42 );

    v cv;
    cv.sum = 0;
    cv.toAddS = 0;
    cv.toAddD = 0;
    for ( k = 1 ; (1<<k) < n ; k ++ ) {}

    it.resize( (1<<k+1)+42 );

    it[1].sz = (1<<k);
    for (long long i = 2 ; i < (1<<k+1) ; i ++ ) {
        it[i].sz = it[i/2].sz/2;
        it[i].sum = 0;
        it[i].toAddS = 0;
        it[i].toAddD = 0;
    }


    for ( int i = 0 ; i < q ; i ++ ) {
        int t;
        cin >> t;
        if ( t == 1 ) {
            cin >> y >> l >> r >> s >> d;
            int to = sz ++;
            cc.l = l;
            cc.r = r+1;
            cc.toInd = to;
            cc.s = s;
            cc.d = d;
            tr[ onInd[y] ].push_back( to );

            parU[to] = cc;

            onInd[y] = to;
        }else if ( t == 2 ) {
            cin >> y >> l >> r;
            ind2[ onInd[y] ].push_back( q2sz ++ );
            q2[ onInd[y] ].push_back ( make_pair( l, r+1 ) );
        }else {
            cin >> y1 >> y2;
            onInd[y2] = onInd[y1];
        }
    }

    dfs2( 0 );

    int x;
    for ( int i = 0 ; i < dfsOr.size() ; i ++ ) {
        x = dfsOr[i];
       // cout << i << " => "<< x << ", " << es[i] << "\n";

        if ( es[i] == 0 ) {
        //    cout << "upd: " << parU[x].l << " " << parU[x].r << " " << parU[x].s << " " << parU[x].d << "\n";
            add( parU[x].l, parU[x].r, parU[x].s, parU[x].d );

            for ( int j = 0 ; j < ind2[x].size() ; j ++ ) {
            //    cout << q2[x][i].first << " " << q2[x][i].second << "   =   " << sum( q2[x][i].first, q2[x][i].second ) << "\n";
                ans[ ind2[x][j] ] = sum( q2[x][j].first, q2[x][j].second );
            }

        }else {
            add( parU[x].l, parU[x].r, -parU[x].s, -parU[x].d );
        }
    }


    for ( int i = 0 ; i < q2sz ; i ++ ) {
        cout << ans[i] << "\n";
    }

    return 0;
}

/*
10 15
1 1 1 5 1 2
2 1 1 1
2 1 5 5
2 1 1 10
2 2 1 10
3 1 2
2 2 1 10
1 2 6 10 1 2
2 2 1 10
2 1 1 10
2 2 5 6
1 1 1 10 -1 -2
2 2 1 10
2 1 1 5
2 1 6 10

*/

