#include<bits/stdc++.h>
using namespace std;
const int nmax=1e5+42,LIM=4*1e4+42;
struct seq
{
long long from,to,st,d;
};
struct query
{
int type,row;
seq s;
};
int n,q;
query inp[nmax];
vector< seq > tree[4*nmax];
void update_tree(int node)
{
    int mem;
    for(auto k:tree[node])
    {
    int av=(k.from+k.to)/2;
    mem=k.to;
    k.to=av;
    tree[node*2].push_back(k);

    k.to=mem;
    k.st=k.st+(av+1-k.from)*k.d;
    k.from=av+1;
    tree[node*2+1].push_back(k);
    }
tree[node].clear();
}
void update(int node,int l,int r,seq now)
{
if(l==now.from&&r==now.to)
{
tree[node].push_back(now);
return;
}
update_tree(node);
int av=(l+r)/2;
int mem=now.to;
    if(now.from<=av)
    {
    now.to=mem;
    update(node*2,l,av,now);
    }
    if(av<now.to)
    {
    now.to=mem;
        if(av<now.from)
            update(node*2+1,av+1,r,now);
        else//now.from<=av
        {
            now.st=now.st+now.d*(av+1-now.from);
            now.from=av+1;
            update(node*2+1,av+1,r,now);
        }
    }
}
long long eval(int node)
{
long long sum=0,s;
for(auto k:tree[node])
    {
    s=k.to-k.from;
    sum=sum+k.st*(s+1)+k.d*s*(s+1);
    }
return sum;
}
long long query(int node,int l,int r,int lq,int rq)
{
if(l==lq&&r==rq)return eval(node);
update_tree(node);
int av=(l+r)/2;
long long now=0;
if(lq<=av)now=now+query(node*2,l,av,lq,min(av,rq));
if(av<rq)now=now+query(node*2+1,av+1,r,max(av+1,lq),rq);
return now;
}
int main()
{
scanf("%i%i",&n,&q);
for(int i=1;i<=q;i++)
{
scanf("%i",&inp[i].type);
assert(inp[i].type!=3);
    if(inp[i].type==1)
    {
    scanf("%i%i%i%i%i",&inp[i].row,&inp[i].s.from,&inp[i].s.to,&inp[i].s.st,&inp[i].s.d);
    update(1,1,n,inp[i].s);
    }
    if(inp[i].type==2)
    {
    scanf("%i%i%i",&inp[i].row,&inp[i].s.from,&inp[i].s.to);
    printf("%i\n",query(1,1,n,inp[i].s.from,inp[i].s.to));
    }
    if(inp[i].type==3)
    {
    scanf("%i%i",&inp[i].s.from,&inp[i].s.to);
    }
}

return 0;
}
/*
5 4
1 1 1 5 1 2
1 1 1 5 1 3
2 1 1 3
2 1 3 5
*/
