#include<iostream>
#include<set>
using namespace std;
const int MAXN=100005;
struct tree{
	tree *leftT,*rightT;
	long long sum,beg,k;
	tree(){
		leftT=nullptr;
		rightT=nullptr;
		sum=0;
		beg=0;
		k=0;
	}
};
tree* rows[MAXN];
void addArithm(int a,int b,int i,int j,tree* &vert,long long beg,long long k){
	if(j<a||b<i||a>b) return;
	if(vert==nullptr){
		vert=new tree;
	}
	int len=b-a+1;
	if(i<=a&&b<=j){
		beg+=(a-i)*k;
		vert->sum+=len*beg+(len*(len-1)/2)*k;
		vert->beg+=beg;
		vert->k+=k;
		if(vert->sum==0&&vert->beg==0&&vert->k==0){
			delete vert;
			vert=nullptr;
		}
		return;
	}
	vert->sum=len*vert->beg+(len*(len-1)/2)*vert->k;
	addArithm(a,(a+b)/2,i,j,vert->leftT,beg,k);
	if(vert->leftT!=nullptr){
		vert->sum+=vert->leftT->sum;
	}
	addArithm((a+b)/2+1,b,i,j,vert->rightT,beg,k);
	if(vert->rightT!=nullptr){
		vert->sum+=vert->rightT->sum;
	}
}
long long sum(int a,int b,int i,int j,tree* vert){
	if(vert==nullptr) return 0;
	if(j<a||b<i||a>b) return 0;
	if(i<=a&&b<=j){
		return vert->sum;
	}
	int beg=max(a,i);
	int ender=min(b,j);
	int len=ender-beg+1;
	long long ans=len*(vert->beg+(beg-a)*vert->k)+(len*(len-1)/2)*vert->k;
	ans+=sum(a,(a+b)/2,i,j,vert->leftT);
	ans+=sum((a+b)/2+1,b,i,j,vert->rightT);
	return ans;
}
/*void eraser(tree* &vert){
	if(vert==nullptr) return;
	eraser(vert->leftT);
	eraser(vert->rightT);
	delete vert;
	vert=nullptr;
}*/
void copyT(tree* &vert,tree* temp){
	if(temp==nullptr){
		if(vert!=nullptr){
			delete vert;
			vert=nullptr;
		}
		return;
	}
	if(vert==nullptr){
		vert=new tree;
	}
	vert->sum=temp->sum;
	vert->beg=temp->beg;
	vert->k=temp->k;
	copyT(vert->leftT,temp->leftT);
	copyT(vert->rightT,temp->rightT);
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n,q;
	cin>>n>>q;
	int t,r,a,b,c,d;
	for(int i=0;i<q;i++){
		cin>>t>>r;
		r--;
		if(t==1){
			cin>>a>>b>>c>>d;
			addArithm(1,n,a,b,rows[r],c,d);
		}
		if(t==2){
			cin>>a>>b;
			cout<<sum(1,n,a,b,rows[r])<<"\n";
		}
		if(t==3){
			cin>>a;
			a--;
			copyT(rows[a],rows[r]);
		}
	}
	return 0;
}
