# include <cstdio>
# include <vector>
# include <map>
# include <algorithm>

using namespace std;

const int MAX_N = 13;
const int MOD = 1000000007;

int n;

char s[MAX_N * 12];

char mo[13] = {'J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D', '#'};

int f[256];

int sum[8][MAX_N * 12];

map <vector <int>, int> m;

int go (int x, vector <int> st)
{
	if (x == n * 12)
		return true;
		
	if (m.find (st) != m.end ())
		return m[st];
		
	int ans = 0, cnt[7];
	
	for (int i = 0; i < 7; i ++)
		cnt[i] = 0;
	
	bool fl = false;
	int ppp;
	char c;
		
	for (int i = 0; !fl && i < n; i ++)
	{
		if (st[i] < 12 && (s[x] == '?' || mo[st[i]] == s[x]))
		{
			st[i] ++;
			ans += go (x + 1, st);
			if (ans >= MOD)
				ans -= MOD;
			st[i] --;
		}
		
		ppp = 0;	
		
		for (int j = st[i]; j < 12; j ++)
		{
			c = f[mo[j]];
			cnt[c] ++;
			if (cnt[c] > sum[c][x + 1])
				ppp += cnt[c] - sum[c][x + 1];
		}
		if (ppp > s[f['?']])
			fl = true;
	}
	
	m[st] = ans;
	return ans;
}

int main ()
{
	int i, j;
	
	scanf ("%d", &n);
	scanf ("%s", s);
	
	f['J'] = 0;
	f['F'] = 1;
	f['M'] = 2;
	f['A'] = 3;
	f['S'] = 4;
	f['N'] = 5;
	f['D'] = 6;
	f['?'] = 7;
	
	for (i = 0; i < 12; i ++)
		for (j = n * 12 - 1; j >= 0; j --)
			sum[f[mo[i]]][j] = sum[f[mo[i]]][j + 1] + (s[j] == mo[i]); 

	for (j = n * 12 - 1; j >= 0; j --)
		sum[f['?']][j] = sum[f['?']][j + 1] + (s[j] == '?'); 
	
	
	vector <int> st;
	
	for (i = 0; i < n; i ++)
		st.push_back (0);
	
	printf ("%d\n", go (0, st));

	return 0;
}

