# include "bookshelf.h"
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int ans[MAX_N];

int pos[MAX_N];
int ipos[MAX_N];

long long invn;

int cnt;

bool comp (int x, int y)
{
	if (x == y)
		return false;
	long long old = invn;
	bool fl = false;
	if (pos[x] > pos[y])
		fl = true;
	
	invn = bookswap (pos[x], pos[y]);
	ipos[pos[x]] = y;
	ipos[pos[y]] = x;
	swap (pos[x], pos[y]);
		
	cnt ++;
	
	return (old > invn) ^ fl;
}

void bookshelf (int n, long long inv)
{
	
	invn = inv;
	
	int i, ma = 1;
	
	for (i = 1; i <= n; i ++)
		pos[i] = ipos[i] = i;
	
	for (i = 2; i <= n; i ++)
		if (!comp (ma, i))
			ma = i;
			
	comp (ipos[1], ma);
	
	ans[ma] = n;
	
	int f = 0, x, y;
	
	for (i = 1; i <= n; i ++)
	{
		if (i == ma)
			continue;
		if (!f)
		{
			if (pos[i] != n)
			{
				x = i;
				y = ipos[n];
				
				ipos[pos[x]] = y;
				ipos[pos[y]] = x;
				swap (pos[x], pos[y]);
			
				invn = bookswap (x, y);
			}
		
			int old = invn;
			
			x = ma;
			y = pos[i];
			
			invn = bookswap (x, y);
			
			ans[i] = invn - old + n; 
		}
		else
		{
			if (pos[i] != 1)
			{
				x = i;
				y = ipos[1];
				
				ipos[pos[x]] = y;
				ipos[pos[y]] = x;
				swap (pos[x], pos[y]);
			
				invn = bookswap (x, y);
			}
		
			int old = invn;
			
			x = ma;
			y = pos[i];
			
			invn = bookswap (x, y);
			
			ans[i] = old - invn + n; 
		}
		
		f ^= 1;
	}
			
	answer (ans);
}

