# include "bookshelf.h"
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int ans[MAX_N];

int pos[MAX_N];
int ipos[MAX_N];

long long invn;

int cnt;

bool comp (int x, int y)
{
	if (x == y)
		return false;
	long long old = invn;
	bool fl = false;
	if (pos[x] > pos[y])
		fl = true;
	
	invn = bookswap (pos[x], pos[y]);
	ipos[pos[x]] = y;
	ipos[pos[y]] = x;
	swap (pos[x], pos[y]);
		
	cnt ++;
	
	return (old > invn) ^ fl;
}

void bookshelf (int n, long long inv)
{
	
	invn = inv;
	
	int i, ma = 1;
	
	for (i = 1; i <= n; i ++)
		pos[i] = ipos[i] = i;
	
	for (i = 2; i <= n; i ++)
		if (!comp (ma, i))
			ma = i;
			
	comp (ipos[1], ma);
	
	ans[ma] = n;
	
	///printf ("max %d %d %d\n", ma, pos[ma], ipos[pos[ma]]);
	
	int f = 0, x, y;
	
	for (i = 1; i <= n; i ++)
	{
		if (i == ma)
			continue;
		if (!f)
		{
			///printf ("--> %d %d %d\n", i, pos[i], ipos[pos[i]]);
		
			if (pos[i] != n)
			{
				x = i;
				y = ipos[n];
				
				invn = bookswap (pos[x], pos[y]);
				
				ipos[pos[x]] = y;
				ipos[pos[y]] = x;
				swap (pos[x], pos[y]);
			}
		
			
			///printf ("++> %d %d %d\n", i, pos[i], ipos[pos[i]]);
		
			int old = invn;
			
			x = ma;
			y = i;
			
			invn = bookswap (pos[x], pos[y]);
			
			ipos[pos[x]] = y;
			ipos[pos[y]] = x;
			swap (pos[x], pos[y]);
			
			ans[i] = (invn - old + 2 * n - 1) / 2; 
			
			
			///printf ("ans> %d %d %d = %d\n", i, pos[i], ipos[pos[i]], ans[i]); 
		}
		else
		{
			///printf ("--> %d %d %d\n", i, pos[i], ipos[pos[i]]);
			if (pos[i] != 1)
			{
				x = i;
				y = ipos[1];
				
				invn = bookswap (pos[x], pos[y]);
				
				ipos[pos[x]] = y;
				ipos[pos[y]] = x;
				swap (pos[x], pos[y]);
			}
				
			///printf ("++> %d %d %d\n", i, pos[i], ipos[pos[i]]);
				
			int old = invn;
			
			x = ma;
			y = i;
			
			invn = bookswap (pos[x], pos[y]);
			
			ipos[pos[x]] = y;
			ipos[pos[y]] = x;
			swap (pos[x], pos[y]);
			
			ans[i] = (old - invn + 2 * n - 1) / 2; 
			
			///printf ("ans> %d %d %d = %d\n", i, pos[i], ipos[pos[i]], ans[i]); 
		}
		
		f ^= 1;
	}
			
	answer (ans);
}

