#include <bits/stdc++.h>
#include "bookshelf.h"

#define BookShelf bookshelf
#define BookSwap bookswap
#define Answer answer

using namespace std;

const int MAX_N = 1e5 + 5;

int N, ans[MAX_N];
vector< int > shelf, inds;

/**
long long BookSwap(int ind1, int ind2) {
	swap(shelf[ind1], shelf[ind2]);

	long long cnt = 0;
	for(int i = 1; i <= N; i++) {
		for(int j = i - 1; j >= 1; j--) {
			if(shelf[i] < shelf[j]) {
				cnt++;
			}
		}
	}

	return cnt;
}

void Answer(int p[]) {
	for(int i = 1; i <= N; i++) {
		cout << p[i] << " ";
	}
	cout << endl;
}
*/

void BookShelf(int n, long long invCnt) {
	N = n;

	inds.resize(n + 1);
	for(int i = 1; i <= n; i++) {
		inds[i] = i;
	}
	
	/**
	//push 1 to front
	for(int i = n - 1; i >= 1; i--) {
		long long newCnt = BookSwap(i, i + 1);
		swap(inds[i], inds[i + 1]);

		if(newCnt > invCnt) {
			BookSwap(i, i + 1);
			swap(inds[i], inds[i + 1]);
		}
		else {
			invCnt = newCnt;
		}
	}

	// push n to back
	for(int i = 1; i <= n - 1; i++) {
		long long newCnt = BookSwap(i, i + 1);
		swap(inds[i], inds[i + 1]);

		if(newCnt > invCnt) {
			BookSwap(i, i + 1);
			swap(inds[i], inds[i + 1]);
		}
		else {
			invCnt = newCnt;
		}
	}
	*/

	int minInv = invCnt, indMin = 1, maxInv = invCnt, indMax = 1;
	for(int i = 2; i <= n; i++) {
		long long aux = BookSwap(i, 1);
		BookSwap(i, 1);

		if(aux > maxInv) {
			maxInv = aux;
			indMax = i;
		}
		if(aux < minInv) {
			minInv = aux;
			indMin = i;
		}
	}

	/**
	for(int32_t i = 1; i <= n; i++) {
		cout << shelf[i] << " ";
	}
	cout << endl;
	*/

	invCnt = BookSwap(indMin, 1);
	swap(inds[indMin], inds[1]);

	invCnt = BookSwap(indMax, n);
	swap(inds[indMax], inds[n]);
	
	ans[inds[1]] = 1;
	ans[inds[n]] = n;
	for(int i = 1; i <= n; i++) {
		long long aux1 = (BookSwap(1, i) - invCnt + 1) / 2;
		BookSwap(1, i);

		long long aux2 = (n - i - (BookSwap(i, n) - invCnt - (n - i))) / 2;
		BookSwap(i, n);
		
		//cout << inds[i] << "->" << aux1 << " " << aux2 << endl;
		ans[inds[i]] = aux1 + aux2 + 1;
	}
	
	Answer(ans);
}
	
/**
int main() {
	shelf = { 0, 4, 3, 1, 5, 2 };

	BookShelf(5, 6);	
}
*/
