#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include "bookshelf.h"
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 2e5 + 5;

int p[N];
int Inversions;

bool is_less(int i, int j)
{
   int new_Inversions = bookswap(i, j);

  // cerr << i << " " << j << endl;

   bool res;
   if(Inversions  < new_Inversions)
    res = true;
   else
    res = false;

   bookswap(i, j);

   return res;
}

void merge_sort(vector <int> &v)
{
   if(v.size() <= 1)
    return;

   int mid = ( (int)v.size() - 1) / 2;
   int i, j;
   vector <int> l, r;

   for(i = 0; i <= mid; i++)
    l.pb(v[i]);
   for(i = mid + 1; i < v.size(); i++)
    r.pb(v[i]);

   v.clear();

   merge_sort(l);
   merge_sort(r);

   i = j = 0;
   while(i < l.size() && j < r.size())
   {
       if(is_less(l[i], r[j]))
       {
           v.pb(l[i]);
           i++;
       }
       else
       {
           v.pb(r[j]);
           j++;
       }
   }

   while(i < l.size())
   {
       v.pb(l[i]);
       i++;
   }
   while(j < r.size())
   {
       v.pb(r[j]);
       j++;
   }
}

vector <int> ans;
void bookshelf(int n, long long Inv)
{
    Inversions = Inv;

    int i;
    for(i = 1; i <= n; i++)
        ans.pb(i);

    merge_sort(ans);
    for(i = 0; i < n; i++)
        p[ans[i]] = i + 1;

    answer(p);
}
