#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include "bookshelf.h"
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 2e5 + 5;

int p[N];
long long Inver;

long long deltas;
long long rem[N];

void bookshelf(int n, long long inversions)
{
    Inver = inversions;

    if(n == 2)
    {
        long long new_Inver = bookswap(1, 2);
        if(Inver > new_Inver)
        {
            p[1] = 2;
            p[2] = 1;
        }
        else
        {
            p[1] = 1;
            p[2] = 2;
        }

        answer(p);
        return;
    }


    int less_than_first = 0;
    for(int i = n; i > 1; i--)
    {
        long long new_Inver = bookswap(1, n);
        bookswap(1, n);

        long long dlt = Inver - new_Inver;

        if(dlt > 0) /// 1 > i
            dlt++;
        else
            dlt--;

        rem[i] = dlt;

       // cerr << i << " " << rem[i] << endl;

        if(dlt > 0)
            less_than_first++;

        if(i > 2)
        {
            Inver = bookswap(n, i - 1);
        }
    }

    p[1] = 1 + less_than_first;

    for(int i = 2; i <= n; i++)
    {
        rem[i] = 1LL * (p[1] - 1 - (n - p[1])) - rem[i];

       // cerr << rem[i] + n - 1 << endl;

        p[i] = ((rem[i] + n - 1) / 2) + 1;
    }

    answer(p);
}
